#!/usr/bin/python

"""
This file is part of Visuse.

Copyright (C) 2010 Jose Luis Lopez Pino jllopezpino@gmail.com

Visuse is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Visuse is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Visuse.  If not, see <http://www.gnu.org/licenses/>.

"""

import urllib
import json
from classes import Resultado, ImageLink


class GoogleImages(Resultado):
    def __init__(self, name, url, summary, width, height, context_url, thumbnail):
        Resultado.__init__(self, name, url)
        self.summary = summary
        self.width = width
        self.height = height
        self.context_url = context_url
        self.thumbnail = thumbnail


def AddResult(resultList, entry):
	# More properties in:
	# http://code.google.com/intl/es/apis/ajaxsearch/documentation/reference.html#_class_GimageResult
	
	thumbnail = ImageLink(entry['tbUrl'], entry['tbWidth'], entry['tbHeight'])
	
	resultList.append(GoogleImages( \
		entry['titleNoFormatting'], \
		entry['unescapedUrl'], \
		entry['contentNoFormatting'], \
		entry['width'], \
		entry['height'], \
		entry['originalContextUrl'], \
		thumbnail
	))



def PrintGoogleImages(resultList):
	for n in range(0, len(resultList)):
		print '=====', n, '====='
		print resultList[n].name
		print resultList[n].url
		print resultList[n].summary
		print '\n'


def SearchGoogleImages(search_terms):
	
	query = urllib.urlencode({'q'   : search_terms,
								'v'   : '1.0',      # obligatory!!!
								'rsz' : 'large'})   # 8 results per query

	url = 'http://ajax.googleapis.com/ajax/services/search/images?%s' \
		% (query)
	
	file = urllib.urlopen(url).read()

	#creamos un diccionario con los datos que nos interesan
	resultDictionary = json.loads(file)['responseData']['results']

	resultList = []
	
	for i in resultDictionary:
		AddResult(resultList, i)
		#~ print i['title'] + ": " + i['url']
		
	#~ PrintGoogleImages(resultList)
 	return resultList;
 

 
#~ SearchGoogleImages('big bang theory')


